
void make_istogramma()
{
  unsigned int isto[64];
  int risultato,x,y;
  double parametro;

  /* Azzero il vettore per evitare sorprese  */
  for (x=0;x<64;++x)
    isto[x]=0;

  /* Calcolo l' istogramma dei livelli di grigio */

  for (x=0;x<64;++x)             /* Colori sgargianti per l' istogramma */
   setrgbpalette(x+64,x,x,x);

  setrgbpalette(129,0,20,40);
  setrgbpalette(130,0,40,40);
  setrgbpalette(131,20,14,4);

  for (y=0;y<200;++y)
    for (x=0;x<320;++x)
       {
	  putpixel(x,y,pagina1[x][y]);
	  if (pagina1[x][y] <64) ++isto[pagina1[x][y]];
       }

   setcolor(131);          /* Cancello un pezzo di immagine  */
   bar(90,40,250,160);

   /* costruisco l'asse dei livelli e l' asse logaritmico */
   setcolor(129);
   line(100,156,240,156);
   line(106,160,106,40);
   for (x=1;x<=10;++x)
    { if (x==1) setcolor(130);else setcolor(129);
      parametro = x;
      risultato = log10(parametro)*25;
      line(100,155-risultato,240,155-risultato);
    }
   for (x=10;x<=100;x+=10)
    { if (x==10) setcolor(130);else setcolor(129);
      parametro = x;
      risultato = log10(parametro)*25;
      line(100,155-risultato,240,155-risultato);
    }
   for (x=100;x<=1000;x+=100)
    { if (x==100) setcolor(130);else setcolor(129);
      parametro = x;
      risultato = log10(parametro)*25;
      line(100,155-risultato,240,155-risultato);
    }
   for (x=1000;x<=10000;x+=1000)
    { if ((x==1000) || (x==10000)) setcolor(130);else setcolor(129);
      parametro = x;
      risultato = log10(parametro)*25;
      line(100,155-risultato,240,155-risultato);
    }
   setcolor(129);
   risultato = log10(20000)*25;
   line(100,155-risultato,240,155-risultato);

   risultato = log10(30000)*25;
   line(100,155-risultato,240,155-risultato);

   for (x=0;x<64;++x)
    {
     if ((x/10*10)==x) setcolor(130); else setcolor(129);
     line(106+2*x,155,106+2*x,158);
    }

   /* disegno l' istogramma dei livelli di grigio */
   for (x=0;x<64;++x)
     if (isto[x] > 0)
     {
	parametro = isto[x];
	risultato = log10(parametro)*25;
	setcolor(x+64);
	line(106+2*x,155,106+2*x,155-risultato);
     }
}

void istogramma()
{
  init_graph();
  make_istogramma();
  getch();
  close_graph();
}